diff -arcN emacs-18.55/src/syntax.c nemacs-3.3.2/src/syntax.c
*** emacs-18.55/src/syntax.c	Tue Jan 19 20:49:45 1988
--- nemacs-3.3.2/src/syntax.c	Fri Jun  8 19:56:51 1990
***************
*** 1,3 ****
--- 1,16 ----
+ /* 88.1.5   modified for Nemacs Ver.2.0 by K.Handa */
+ /* 88.6.1   modified for Nemacs Ver.2.1 by K.Handa */
+ /* 89.9.19  modified for Nemacs Ver.3.2 by K.Handa */
+ /* 89.12.12 modified for Nemacs Ver.3.2.1 by K.Handa
+ 	Numeric argument of minus value is handled
+ 	correctly in scan_words. */
+ /* 90.4.25  modified for Nemacs Ver.3.3.2 by Y.Ogawa
+ 	Handle Sjapanese in scan_lists and scan_sexps_forward correctly. */
+ /* 90.6.6   modified for Nemacs Ver.3.3.2 by abe@sunrise.hallab.co.jp
+ 	'unsigned char prev;' in scan_sexps_forward */
+ /* 90.6.9   modified for Nemacs Ver.3.3.2 by takagi@sdl.hitachi.co.jp
+ 	SWITCH_ENUM_BUG	is considered */
+ 
  /* GNU Emacs routines to deal with syntax tables; also word and list parsing.
     Copyright (C) 1985, 1987 Free Software Foundation, Inc.
  
***************
*** 25,30 ****
--- 38,49 ----
  #include "commands.h"
  #include "buffer.h"
  #include "syntax.h"
+ #ifdef NEMACS  /* 88.1.4, 89.9.19  by K.Handa.4 */
+ #include "kanji.h"
+ 
+ unsigned char category_table[0400];
+ unsigned char ex_category_table[0200];
+ #endif  /* NEMACS */
  
  Lisp_Object Qsyntax_table_p, Vstandard_syntax_table;
  
***************
*** 126,132 ****
--- 145,155 ----
      0377, 0377, 0377, 0377, 0377, 0377, 0377, (char) Sword,
      0377, 0377, 0377, 0377, (char) Sescape, 0377, 0377, (char) Ssymbol,
      0377, 0377, 0377, 0377, 0377, 0377, 0377, 0377,   /* `, a, ... */
+ #ifdef NEMACS  /* 89.9.19  by K.Handa */
+     0377, 0377, (char) Sjapanese, 0377, 0377, 0377, 0377, 0377,
+ #else
      0377, 0377, 0377, 0377, 0377, 0377, 0377, 0377,
+ #endif
      0377, 0377, 0377, 0377, 0377, 0377, 0377, (char) Sword,
      0377, 0377, 0377, 0377, 0377, 0377, 0377, 0377
    };
***************
*** 133,143 ****
  
  /* Indexed by syntax code, give the letter that describes it. */
  
  char syntax_code_spec[13] =
    {
      ' ', '.', 'w', '_', '(', ')', '\'', '\"', '$', '\\', '/', '<', '>'
    };
! 
  DEFUN ("char-syntax", Fchar_syntax, Schar_syntax, 1, 1, 0,
    "Return the syntax code of CHAR, described by a character.\n\
  For example, if CHAR is a word constituent, ?w is returned.\n\
--- 156,173 ----
  
  /* Indexed by syntax code, give the letter that describes it. */
  
+ #ifdef NEMACS  /* 89.9.19  by K.Handa */
+ char syntax_code_spec[14] =
+   {
+     ' ', '.', 'w', '_', '(', ')', '\'', '\"', '$', '\\', '/', '<', '>', 'j'
+   };
+ #else
  char syntax_code_spec[13] =
    {
      ' ', '.', 'w', '_', '(', ')', '\'', '\"', '$', '\\', '/', '<', '>'
    };
! #endif
! 
  DEFUN ("char-syntax", Fchar_syntax, Schar_syntax, 1, 1, 0,
    "Return the syntax code of CHAR, described by a character.\n\
  For example, if CHAR is a word constituent, ?w is returned.\n\
***************
*** 150,155 ****
--- 180,251 ----
    return make_number (syntax_code_spec[(int) SYNTAX (0xFF & XINT (ch))]);
  }
  
+ #ifdef NEMACS  /* 88.1.18, 88.6.1, 89.9.19  by K.Handa */
+ /* Convert a letter which signifies a category code
+  into the code it signifies. */
+ 
+ char category_spec_code[0200] =
+   { 0377, 0377, 0377, 0377, 0377, 0377, 0377, 0377,
+     0377, 0377, 0377, 0377, 0377, 0377, 0377, 0377,
+     0377, 0377, 0377, 0377, 0377, 0377, 0377, 0377,
+     0377, 0377, 0377, 0377, 0377, 0377, 0377, 0377,
+     (char) Cwhitespace, 0377, (char) Cstring, 0377,
+         (char) Cmath, 0377, 0377, (char) Cquote,
+     (char) Copen, (char) Cclose, 0377, 0377,
+ 	0377, (char) Cwhitespace, (char) Cpunct, (char) Ccharquote,
+     0377, 0377, 0377, 0377, 0377, 0377, 0377, 0377,
+     0377, 0377, 0377, 0377,
+ 	(char) Ccomment, 0377, (char) Cendcomment, 0377,
+     0377, 0377, 0377, (char) CJspkanji,			/* @, A, ... */
+         0377, 0377, 0377, 0377,
+     (char) CJsphira, 0377, 0377, (char) CJspkata,
+         0377, 0377, 0377, 0377,
+     0377, 0377, 0377, 0377, 0377, 0377, 0377, 0377,
+     0377, 0377, 0377, 0377, (char) Cescape, 0377, 0377, (char) Csymbol,
+     0377, (char) CJalpha, 0377, (char) CJkanji,		/* `, a, ... */
+         0377, 0377, 0377, (char) CJgreek,
+     (char) CJhira, 0377, 0377, (char) CJkata, 0377, 0377, 0377, 0377,
+     0377, 0377, (char) CJrussian, (char) CJsymbol,
+         0377, (char) CJundef, 0377, (char) Cword,
+     0377, 0377, 0377, 0377, 0377, 0377, 0377, 0377,
+   };
+ 
+ /* Indexed by category code, give the letter that describes it. */
+ 
+ char category_code_spec[24] =
+   {
+     ' ', '.', 'w', '_', '(', ')', '\'', '\"', '$', '\\', '/', '<', '>',
+     's', 'u', 'a', 'h', 'H', 'k', 'K', 'g', 'r', 'c', 'C'
+   };
+ 
+ DEFUN ("char-category", Fchar_category, Schar_category, 1, 1, 0,
+   "One argument, POS or STRING.\n\
+ Return the category code of the character at POS\n\
+ or the first charater of STRING, described by a character.\n\
+ For example, if the character is a Hiragana, ?h is returned.\n\
+ The characters that correspond to various category codes\n\
+ are listed in the entry INFO documentation.\n\
+ Return NIL if POS is out of range or STRING is NULL.")
+   (arg)
+      Lisp_Object arg;
+ {
+   register Lisp_Object val;
+   register unsigned char c1, c2;
+ 
+   if (XTYPE ((arg)) != Lisp_String) {
+     CHECK_NUMBER_COERCE_MARKER (arg, 0);
+     if (XINT(arg) < FirstCharacter || XINT(arg) > NumCharacters) return Qnil;
+     c1 = CharAt(XINT(arg));
+     c2 = (XINT(arg) == NumCharacters) ? 0 : CharAt(XINT(arg+1));
+   } else {
+     if (XSTRING(arg)->size == 0) return Qnil;
+     c1 = *(XSTRING(arg)->data);
+     c2 = (XSTRING(arg)->size == 1) ? 0 : *(XSTRING(arg)->data + 1);
+   }
+   return make_number (category_code_spec[(int) CATEGORY(c1, c2)]);
+ }
+ #endif  /* NEMACS */
+ 
  /* This comment supplies the doc string for modify-syntax-entry,
     for make-docfile to see.  We cannot put this in the real DEFUN
     due to limits in the Unix cpp.
***************
*** 312,317 ****
--- 408,417 ----
        InsStr ("comment"); break;
      case Sendcomment:
        InsStr ("endcomment"); break;
+ #ifdef NEMACS  /* 89.9.19  by K.Handa */
+     case Sjapanese:
+       InsStr ("Japanese"); break;
+ #endif
      default:
        InsStr ("invalid");
        return;
***************
*** 365,375 ****
--- 465,488 ----
     If that many words cannot be found before the end of the buffer, return 0.
     `count' negative means scan backward and stop at word beginning.  */
  
+ #ifdef NEMACS  /* 89.9.14  by K.Handa */
+ #define Scan_Hiragana { \
+   while ((from += 2) < end) { \
+ 	category1 = CATEGORY(CharAt (from), CharAt (from + 1)); \
+ 	if (!CTGHIRA(category1)) break; \
+   } \
+ }
+ #endif
+ 
  scan_words (from, count)
       register int from, count;
  {
    register int beg = FirstCharacter;
    register int end = NumCharacters + 1;
+ #ifdef NEMACS  /* 88.1.4, 89.9.19  by K.Handa */
+   register enum categorycode category1, category2;
+   register unsigned char c1, c2;
+ #endif
  
    immediate_quit = 1;
    QUIT;
***************
*** 384,392 ****
--- 497,566 ----
  	      return 0;
  	    }
  	  if (SYNTAX(CharAt (from)) == Sword)
+ #ifdef NEMACS  /* 88.1.4, 89.9.14, 89.10.19  by K.Handa */
+ 	    {
+ 	      category1 = Cword;
+ 	      break;
+ 	    }
+ 	  if (from == end - 1)
+ 	    {
+ 	      immediate_quit = 0;
+ 	      return 0;
+ 	    }
+ 	  c1 = CharAt (from); c2 = CharAt (from + 1);
+ 	  category1 = CATEGORY(c1, c2);
+ 	  if (CTGWORD(category1)) break;
+ 	  if ((int) category1 >= (int) CJsymbol) from++;
+ #else
  	    break;
+ #endif
  	  from++;
  	}
+ #ifdef NEMACS  /* 88.1.4, 89.9.14, 89.10.19  by K.Handa */
+ #ifdef SWITCH_ENUM_BUG	/* 1990-mar-30 by takagi@sdl.hitachi.co.jp */
+       switch ((int)category1) {
+ #else
+       switch (category1) {
+ #endif
+       case Cword:	/* if normal ascii word */
+ 	while (++from < end && SYNTAX(CharAt (from)) == Sword);
+ 	break;
+       case CJsphira:
+       case CJspkata:
+       case CJspkanji:
+ 	category1 = (enum categorycode) ((int) category1 - 1);
+       case CJhira:
+       case CJkata:
+       case CJkanji:
+ 	end--;
+ 	while ((from += 2) < end) {
+ 	  c1 = CharAt (from); c2 = CharAt (from + 1);
+ 	  category2 = CATEGORY(c1, c2);
+ 	  if (CTGHIRA(category2)) {
+ 	    Scan_Hiragana;
+ 	    break;
+ 	  }
+ 	  if (category2 != category1
+ 	      && category2 != (enum categorycode) ((int) category1 + 1)) {
+ 	    break;
+ 	  }
+ 	}
+ 	break;
+       default:
+ 	end--;
+ 	while ((from += 2) < end) {
+ 	  c1 = CharAt (from); c2 = CharAt (from + 1);
+ 	  category2 = CATEGORY(c1, c2);
+ 	  if (CTGHIRA(category2)) {
+ 	    Scan_Hiragana;
+ 	    break;
+ 	  } else if (category2 != category1) {
+ 	    break;
+ 	  }
+ 	}
+         break;
+       }
+ #else  /* not NEMACS */
        while (1)
  	{
  	  if (from == end) break;
***************
*** 394,399 ****
--- 568,574 ----
  	    break;
  	  from++;
  	}
+ #endif  /* not NEMACS */
        count--;
      }
    while (count < 0)
***************
*** 405,414 ****
--- 580,660 ----
  	      immediate_quit = 0;
  	      return 0;
  	    }
+ #ifdef NEMACS  /* 88.1.4, 89.9.14, 89.10.19  by K.Handa */
+ 	  if (kanji_point(--from) == 2) {
+ 	    from--;
+ 	    c1 = CharAt (from); c2 = CharAt (from + 1);
+ 	    category1 = CATEGORY(c1, c2);
+ 	    if (CTGWORD(category1)) break;
+ 	  } else {
+ 	    if (SYNTAX(CharAt (from)) == Sword) {
+ 	      category1 = Cword;
+ 	      break;
+ 	    }
+ 	  }
+ #else
  	  if (SYNTAX(CharAt (from - 1)) == Sword)
  	    break;
  	  from--;
+ #endif
+ 	}
+ #ifdef NEMACS  /* 88.1.4  by K.Handa */
+       if (category1 == Cword) {
+ 	while (from > beg && SYNTAX(CharAt (from - 1)) == Sword) from--;
+       } else if (CTGHIRA(category1)) {
+ 	while (from > beg + 1) {
+ 	  c2 = CharAt (from - 1);
+ 	  if (SYNTAX(c2) == Sjapanese) {
+ 	    c1 = CharAt (from - 2); 
+ 	    category1 = CATEGORY(c1, c2);
+ 	    if (!CTGHIRA(category1)) break;
+ 	    from -= 2;
+ 	  } else {
+ 	    category1 = CATEGORY(c2, 0);
+ 	    break;
+ 	  }
+ 	}
+       }
+ #ifdef SWITCH_ENUM_BUG	/* 1990-mar-30 by takagi@sdl.hitachi.co.jp */
+       switch ((int)category1) {
+ #else
+       switch (category1) {
+ #endif
+       case CJspkata:
+       case CJspkanji:
+ 	category1 = (enum categorycode) ((int) category1 - 1);
+       case CJkata:
+       case CJkanji:
+ 	while (from > beg + 1) {
+ 	  c2 = CharAt (from - 1);
+ 	  if (SYNTAX(c2) == Sjapanese) {
+ 	    c1 = CharAt (from - 2);
+ 	    category2 = CATEGORY(c1, c2);
+ 	    if (category2 != category1
+ 		&& category2 != (enum categorycode) ((int) category1 + 1))
+ 	      break;
+ 	    from -= 2;
+ 	  } else
+ 	    break;
+ 	}
+ 	break;
+       case CJalpha:
+       case CJgreek:
+       case CJrussian:
+ 	while (from > beg + 1) {
+ 	  c2 = CharAt (from - 1);
+ 	  if (SYNTAX(c2) == Sjapanese) {
+ 	    c1 = CharAt (from - 2);
+ 	    if (category1 != CATEGORY(c1, c2)) break;
+ 	    from -= 2;
+ 	  } else
+ 	    break;
  	}
+ 	break;
+       default:
+ 	break;
+       }
+ #else  /* not NEMACS */
        while (1)
  	{
  	  if (from == beg) break;
***************
*** 416,421 ****
--- 662,668 ----
  	    break;
  	  from--;
  	}
+ #endif  /* not NEMACS */
        count++;
      }
  
***************
*** 490,495 ****
--- 737,745 ----
  	      from++;
  	      /* treat following character as a word constituent */
  	    case Sword:
+ #ifdef NEMACS	/* 90/04/25 by Y.Ogawa */
+ 	    case Sjapanese:
+ #endif
  	    case Ssymbol:
  	      if (depth || !sexpflag) break;
  	      /* This word counts as a sexp; return at end of it. */
***************
*** 507,512 ****
--- 757,765 ----
  		      if (from == stop) goto lose;
  		      break;
  		    case Sword:
+ #ifdef NEMACS	/* 90/04/25 by Y.Ogawa */
+ 		    case Sjapanese:
+ #endif
  		    case Ssymbol:
  		      break;
  		    default:
***************
*** 611,616 ****
--- 864,872 ----
  #endif
  	    {
  	    case Sword:
+ #ifdef NEMACS	/* 90/04/25 by Y.Ogawa */
+ 	    case Sjapanese:
+ #endif
  	    case Ssymbol:
  	      if (depth || !sexpflag) break;
  	      /* This word counts as a sexp; count object finished after passing it. */
***************
*** 804,810 ****
--- 1060,1070 ----
    struct level levelstart[100];
    register struct level *curlevel = levelstart;
    struct level *endlevel = levelstart + 100;
+ #ifdef NEMACS  /* 90.6.6  by abe@sunrise.hallab.co.jp */
+   unsigned char prev;
+ #else
    char prev;
+ #endif
    register int depth;	/* Paren depth of current scanning location.
  			   level - levelstart equals this except
  			   when the depth becomes negative.  */
***************
*** 881,886 ****
--- 1141,1149 ----
  	  goto symstarted;
  	  /* treat following character as a word constituent */
  	case Sword:
+ #ifdef NEMACS	/* 90/04/25 by Y.Ogawa */
+ 	case Sjapanese:
+ #endif
  	case Ssymbol:
  	  if (stopbefore) goto stop;  /* this arg means stop at sexp start */
  	  curlevel->last = from - 1;
***************
*** 899,904 ****
--- 1162,1170 ----
  		  if (from == end) goto endquoted;
  		  break;
  		case Sword:
+ #ifdef NEMACS	/* 90/04/25 by Y.Ogawa */
+ 		case Sjapanese:
+ #endif
  		case Ssymbol:
  		  break;
  		default:
***************
*** 1096,1101 ****
--- 1362,1404 ----
  
    for (i = 0; i < 12; i++)
      XFASTINT (v->contents[".,;:?!#@~^'`"[i]]) = (int) Spunct;
+ 
+ #ifdef NEMACS  /* 88.1.4, 89.9.17  by K.Handa */
+   for (i = 0x80; i < 0xa1; i++)
+     XFASTINT (v->contents[i]) = (int) Spunct;
+   for (i = 0xa1; i < 0xff; i++)
+     XFASTINT (v->contents[i]) = (int) Sjapanese;
+   XFASTINT (v->contents[0xff]) = (int) Spunct;
+ 
+   for (i = 0; i < 0x80; i++)
+     category_table[i] = (unsigned char) XFASTINT (v->contents[i]);
+   for (i = 0x80; i < 0xa1; i++) category_table[i] = (unsigned char) Cpunct;
+   category_table[0xa1] = (unsigned char) CJsymbol;
+   category_table[0xa2] = (unsigned char) CJsymbol;
+   category_table[0xa3] = (unsigned char) CJalpha;
+   category_table[0xa4] = (unsigned char) CJhira;
+   category_table[0xa5] = (unsigned char) CJkata;
+   category_table[0xa6] = (unsigned char) CJgreek;
+   category_table[0xa7] = (unsigned char) CJrussian;
+   category_table[0xa8] = (unsigned char) CJsymbol;
+   for (i = 0xa9; i<0xb0; i++) category_table[i] = (unsigned char) CJundef;
+   for (i = 0xb0; i<0xff; i++) category_table[i] = (unsigned char) CJkanji;
+   category_table[0xff] = (unsigned char) Cpunct;
+ 
+   for (i = 0; i < 0x33; i++) ex_category_table[i] = (unsigned char) CJsymbol;
+   ex_category_table[0x33] = (unsigned char) CJsphira;
+   ex_category_table[0x34] = (unsigned char) CJsphira;
+   ex_category_table[0x35] = (unsigned char) CJsphira;
+   ex_category_table[0x36] = (unsigned char) CJsphira;
+   ex_category_table[0x37] = (unsigned char) CJsymbol;
+   ex_category_table[0x38] = (unsigned char) CJspkanji;
+   ex_category_table[0x39] = (unsigned char) CJspkanji;
+   ex_category_table[0x3a] = (unsigned char) CJspkanji;
+   ex_category_table[0x3b] = (unsigned char) CJspkanji;
+   ex_category_table[0x3c] = (unsigned char) CJspkata;
+   for (i = 0x3d; i <= 0x7f; i++)
+     ex_category_table[i] = (unsigned char) CJsymbol;
+ #endif  /* NEMACS */
  }
  
  syms_of_syntax ()
***************
*** 1122,1127 ****
--- 1425,1433 ----
    defsubr (&Scopy_syntax_table);
    defsubr (&Sset_syntax_table);
    defsubr (&Schar_syntax);
+ #ifdef NEMACS  /* 88.1.18,  89.9.19  by K.Handa */
+   defsubr (&Schar_category);
+ #endif
    defsubr (&Smodify_syntax_entry);
    defsubr (&Sdescribe_syntax);
  
diff -arcN emacs-18.55/src/syntax.h nemacs-3.3.2/src/syntax.h
*** emacs-18.55/src/syntax.h	Tue Sep 30 07:44:35 1986
--- nemacs-3.3.2/src/syntax.h	Wed Jun  6 03:18:37 1990
***************
*** 1,3 ****
--- 1,7 ----
+ /* 88.1.3  modified for Nemacs Ver.2.0 by K.Handa */
+ /* 88.6.1  modified for Nemacs Ver.2.1 by K.Handa */
+ /* 89.9.19 modified for Nemacs Ver.3.2 by K.Handa */
+ 
  /* Declarations having to do with GNU Emacs syntax tables.
     Copyright (C) 1985 Free Software Foundation, Inc.
  
***************
*** 18,24 ****
  file named COPYING.  Among other things, the copyright notice
  and this notice must be preserved on all copies.  */
  
- 
  extern Lisp_Object Qsyntax_table_p;
  extern Lisp_Object Fsyntax_table_p (), Fsyntax_table (), Fset_syntax_table ();
  
--- 22,27 ----
***************
*** 44,49 ****
--- 47,55 ----
      Scharquote,  /* for a character that quotes the following character */
      Scomment,    /* for a comment-starting character */
      Sendcomment, /* for a comment-ending character */
+ #ifdef NEMACS  /* 89.10.19  by K.Handa */
+     Sjapanese,	 /* for a first char of Japanese code */
+ #endif
      Smax	 /* Upper bound on codes that are meaningful */
    };
  
***************
*** 50,55 ****
--- 56,116 ----
  #define SYNTAX(c) \
    ((enum syntaxcode) (XINT (bf_cur->syntax_table_v->contents[c]) & 0377))
  
+ #ifdef NEMACS  /* 88.1.5, 89.9.17, 89.10.19  by K.Handa */
+ enum categorycode {
+   /* For 1-byte code */
+   Cwhitespace,	/* for a whitespace character */
+   Cpunct,	/* for random punctuation characters */
+   Cword,	/* for a word constituent */
+   Csymbol,	/* symbol constituent but not word constituent */
+   Copen,	/* for a beginning delimiter */
+   Cclose,	/* for an ending delimiter */
+   Cquote,	/* for a prefix character like Lisp ' */
+   Cstring,	/* for a string-grouping character like Lisp " */
+   Cmath,	/* for delimiters like $ in Tex. */
+   Cescape,	/* for a character that begins a C-style escape */
+   Ccharquote,	/* for a character that quotes the following character */
+   Ccomment,	/* for a comment-starting character */
+   Cendcomment,	/* for a comment-ending character */
+   /* For Japanese code */
+   CJsymbol,
+   CJundef,
+   CJalpha,
+   CJhira,
+   CJsphira,
+   CJkata,
+   CJspkata,
+   CJgreek,
+   CJrussian,
+   CJkanji,
+   CJspkanji,
+   Cmax		/* Upper bound on codes that are meaningful */
+ };
+ 
+ extern unsigned char category_table[0400];	/* patch by sanewo  88.5.25 */
+ extern unsigned char ex_category_table[0200];
+ #define CATEGORY(c1, c2) \
+   (((SYNTAX(c1)==Sjapanese) && (SYNTAX(c2)==Sjapanese) \
+ 			? ((c1 == 0xa1) \
+ 			  ? (enum categorycode) ex_category_table[c2 & 0177] \
+ 			  : (enum categorycode) category_table[c1]) \
+ 			: (enum categorycode) SYNTAX(c1)))
+ #define CTGJCODE(ctg) ((int)ctg >= (int)CJsymbol && (int)ctg < (int)Cmax)
+ #define CTGHIRA(ctg) \
+   ((enum categorycode)ctg == CJhira || (enum categorycode)ctg == CJsphira)
+ #define CTGKATA(ctg) \
+   ((enum categorycode)ctg == CJkata || (enum categorycode)ctg == CJspkata)
+ #define CTGKANJI(ctg) \
+   ((enum categorycode)ctg == CJkanji || (enum categorycode)ctg == CJspkanji)
+ #define CTGSPECIAL(ctg) \
+   ((enum categorycode)ctg == CJsphira \
+    || (enum categorycode)ctg == CJspkata \
+    || (enum categorycode)ctg == CJspkanji)
+ #define CTGJWORD(ctg) ((int)ctg > (int)CJundef && (int)ctg < (int)Cmax)
+ #define CTGWORD(ctg) ((enum categorycode)ctg == Cword || CTGJWORD (ctg))
+ #define CTGEXTEND(ctg) (ctg = (enum categorycode) ((int)ctg - CTGSPECIAL(ctg)))
+ #endif  /* NEMACS */
+ 
  /* The next 8 bits of the number is a character,
   the matching delimiter in the case of Sopen or Sclose. */
  
***************
*** 81,83 ****
--- 142,148 ----
   (enum syntaxcode) syntax_spec_code['w'] is Sword. */
  
  extern char syntax_spec_code[0400];
+ 
+ #ifdef NEMACS  /* 88.1.17, 88.6.2, 89.9.19  by K.Handa */
+ extern char category_spec_code[0200];
+ #endif  /* NEMACS */
diff -arcN emacs-18.55/src/sysdep.c nemacs-3.3.2/src/sysdep.c
*** emacs-18.55/src/sysdep.c	Tue Aug  8 10:50:43 1989
--- nemacs-3.3.2/src/sysdep.c	Wed Jun  6 03:18:32 1990
***************
*** 1,3 ****
--- 1,6 ----
+ /* 90.1.31  modified for Nemacs Ver.3.3.1 by K.Handa
+  	LPASS8 is set in child process for 8 bit transmission. */
+ 
  /* Interfaces to system-dependent kernel and library entries.
     Copyright (C) 1985, 1986, 1987, 1988 Free Software Foundation, Inc.
  
***************
*** 469,474 ****
--- 472,485 ----
  
  #else /* not HAVE_TERMIO */
    s.sg_flags &= ~(ECHO | CRMOD | ANYP | ALLDELAY | RAW | LCASE | CBREAK | TANDEM);
+ #ifdef NEMACS  /* 90.1.31  by K.Handa */
+ #ifdef LPASS8  /*  Effective, at least, on SunOS 3.?, 4.?, and 4.3bsd */
+   {
+     int arg=LPASS8;
+     ioctl (out, TIOCLBIS, &arg);
+   }
+ #endif /* LPASS8 */
+ #endif /* NEMACS */
  #endif /* not HAVE_TERMIO */
  
    ioctl (out, TIOCSETN, &s);
diff -arcN emacs-18.55/src/term.c nemacs-3.3.2/src/term.c
*** emacs-18.55/src/term.c	Thu Mar 30 00:49:32 1989
--- nemacs-3.3.2/src/term.c	Wed Jun  6 03:18:14 1990
***************
*** 1,3 ****
--- 1,8 ----
+ /* 87.6.5   modified by K.Handa */
+ /* 87.12.10 modified for Nemacs Ver.2.0 by K.Handa */
+ /* 89.2.22  modified for Nemacs Ver.3.0 by K.Handa */
+ /* 90.1.6   modified for Nemacs Ver.3.3.1 by Sanewo (sanewo@sony.co.jp) */
+ 
  /* terminal control module for terminals described by TERMCAP
     Copyright (C) 1985, 1986, 1987 Free Software Foundation, Inc.
  
***************
*** 26,31 ****
--- 31,42 ----
  #include "termchar.h"
  #include "termopts.h"
  #include "cm.h"
+ #ifdef NEMACS  /* 87.6.5  by K.Handa */
+ #undef NULL
+ #include "lisp.h"
+ #include "buffer.h"
+ #include "kanji.h"
+ #endif  /* NEMACS */
  
  #define max(a, b) ((a) > (b) ? (a) : (b))
  #define min(a, b) ((a) < (b) ? (a) : (b))
***************
*** 573,578 ****
--- 584,592 ----
    register char *buf;
    register int c;
    char *first_check;
+ #ifdef NEMACS  /* 89.2.22  by K.Handa */
+   char *buf2;
+ #endif  /* NEMACS */
  
    if (write_chars_hook)
      {
***************
*** 587,599 ****
--- 601,639 ----
  
    if (AutoWrap && curY + 1 == screen_height
        && curX + len - (chars_wasted[curY] & 077) == screen_width)
+ #ifndef NEMACS  /* 90.1.6 by Sanewo */
      len --;
+ #else
+     {
+       len --;
+       if (current_kanji_flag && JCODE(start[len]))
+ 	/* Last char was 2nd byte of kanji.  So shrink one byte more */
+ 	len --;
+     }
+ #endif  /* NEMACS */
  
    cmplus (len);
  
+ #ifdef NEMACS  /* 89.2.9 by K.Handa */
+   if (current_kanji_flag
+       && kanji_display_code != EUC
+       && kanji_display_code != NOCONV) {
+     buf2 = get_kanji_work_area(len, kanji_display_code);
+     len = convert_kanji_code(len, start, buf2,
+ 			     EUC, kanji_display_code,
+ 			     to_kanji_display, to_ascii_display);
+     start = buf2;
+   }
+ #endif  /* NEMACS */
+ 
    first_check = start;
  
+ #ifdef NEMACS  /* 89.2.9  by K.Handa */
+   if ((RPov > len && !TF_underscore && !TF_hazeltine)
+       || current_kanji_flag)
+ #else
    if (RPov > len && !TF_underscore && !TF_hazeltine)
+ #endif
      {
        fwrite (start, 1, len, stdout);
        if (ferror (stdout))
***************
*** 641,646 ****
--- 681,689 ----
  	  fputc (c, termscript);
  	putchar (c);
        }
+ #ifdef NEMACS  /* 89.2.9 by K.Handa */
+   free_kanji_work_area();
+ #endif  /* NEMACS */
  }
  
  /* If start is zero, insert blanks instead of a string at start */
***************
*** 651,656 ****
--- 694,702 ----
  {
    register char *buf;
    register int c;
+ #ifdef NEMACS  /* 89.2.9  by K.Handa */
+   char *buf2;
+ #endif  /* NEMACS */  
  
    if (insert_chars_hook)
      {
***************
*** 669,679 ****
--- 715,754 ----
        return;
      }
  
+ #ifdef NEMACS  /* 89.9.17  by K.Handa */
+   if (TS_ins_char && current_kanji_flag) {
+     int len2 = len;
+     while (len2--) OUTPUT1_IF(TS_ins_char);
+     if (start)
+       write_chars (start, len);
+     return;
+   }
+ #endif
+ 
    turn_on_insert ();
    cmplus (len);
  
+ #ifdef NEMACS  /* 89.2.9 by K.Handa */
+   if (current_kanji_flag
+       && start	/* 89.8.24 by K.Handa */
+       && kanji_display_code != EUC
+       && kanji_display_code != NOCONV) {
+     buf2 = get_kanji_work_area(len, kanji_display_code);
+     len = convert_kanji_code(len, start, buf2,
+ 			     EUC, kanji_display_code,
+ 			     to_kanji_display, to_ascii_display);
+     start = buf2;
+   }
+ #endif  /* NEMACS */
+ 
+ #ifdef NEMACS  /* 89.2.9, 89.8.30  by K.Handa */
+   if (start && ((!TF_underscore && !TF_hazeltine
+ 		 && TS_pad_inserted_char == 0 && TS_ins_char == 0)
+ 		|| current_kanji_flag))
+ #else
    if (!TF_underscore && !TF_hazeltine && start
        && TS_pad_inserted_char == 0 && TS_ins_char == 0)
+ #endif
      {
        fwrite (start, 1, len, stdout);
        if (termscript)
***************
*** 696,701 ****
--- 771,779 ----
  	putchar (c);
  	OUTPUT1_IF (TS_pad_inserted_char);
      }
+ #ifdef NEMACS  /* 89.2.9 by K.Handa */
+   free_kanji_work_area();
+ #endif  /* NEMACS */
  }
  
  delete_chars (n)
diff -arcN emacs-18.55/src/window.c nemacs-3.3.2/src/window.c
*** emacs-18.55/src/window.c	Fri Jun 10 22:07:24 1988
--- nemacs-3.3.2/src/window.c	Wed Jun  6 03:18:15 1990
***************
*** 1,3 ****
--- 1,5 ----
+ /* 89.3.15   modified for Nemacs Ver.3.0 by K.Handa */
+ 
  /* Window creation, deletion and examination for GNU Emacs.
     Does not include redisplay.
     Copyright (C) 1985, 1986, 1987 Free Software Foundation, Inc.
***************
*** 75,80 ****
--- 77,86 ----
  /* Incremented for each window created.  */
  
  static int sequence_number;
+ 
+ #ifdef NEMACS  /* 89.3.13  by K.Handa */
+ Lisp_Object Vminibuf_window_selected, Qminibuf_window_selected;
+ #endif
  
  DEFUN ("windowp", Fwindowp, Swindowp, 1, 1, 0,
    "Returns t if OBJ is a window.")
***************
*** 901,906 ****
--- 907,921 ----
    register struct window *ow = XWINDOW (selected_window);
  
    CHECK_WINDOW (window, 0);
+ #ifdef NEMACS  /* 89.3.13  by K.Handa, S.Tomura */
+   if (minibuf_window == selected_window &&  minibuf_window != window) {
+     Vminibuf_window_selected = Qnil;
+     RedoModes++;
+   } else if (minibuf_window != selected_window && minibuf_window == window) {
+     Vminibuf_window_selected = Qt;
+     RedoModes++;
+   }
+ #endif  /* NEMACS */
  
    w = XWINDOW (window);
  
***************
*** 1944,1949 ****
--- 1959,1972 ----
    DEFVAR_INT ("window-min-width", &window_min_width,
      "*Delete any window less than this wide.");
    window_min_width = 10;
+ 
+ #ifdef NEMACS  /* 89.3.13  by K.Handa */
+   DEFVAR_LISP ("minibuffer-window-selected", &Vminibuf_window_selected,
+     "T means that minibuffer-window is selected.");
+   Vminibuf_window_selected = Qnil;
+   Qminibuf_window_selected = intern ("minibuffer-window-selected");
+   staticpro (&Qminibuf_window_selected);
+ #endif  /* NEMACS */
  
    defsubr (&Sselected_window);
    defsubr (&Sminibuffer_window);
